<?php
/***************************************************************
*  Copyright notice
*
*  (c) 2007 Micha Barthel (barthel@sunbeam-berlin.de)
*  All rights reserved
*
*  This script is part of the TYPO3 project. The TYPO3 project is
*  free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
*
*  The GNU General Public License can be found at
*  http://www.gnu.org/copyleft/gpl.html.
*
*  This script is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*  GNU General Public License for more details.
*
*  This copyright notice MUST APPEAR in all copies of the script!
***************************************************************/

class t3s_library_configuration{
    function addTypoScriptDir($absPath,$relPath,$_EXTKEY,$namePath){
    	$dirs = t3lib_div::get_dirs($absPath);
    	if($dirs != 'error'){
      	foreach((array)$dirs as $value) {
  	        $newAbsPath = $absPath.$value.'/';
  	        $newRealPath = $relPath.$value.'/';
  	        $newNamePath = $namePath.$value.'/';
  			$files = t3lib_div::getFilesInDir($newAbsPath);
  			if(in_array('constants.txt',$files) && in_array('setup.txt',$files) && !in_array('.noStaticTemplate',$files)){
        	t3lib_extMgm::addStaticFile($_EXTKEY, $newRealPath, $newNamePath);
  			}
  		  	t3s_library_configuration::addTypoScriptDir($newAbsPath,$newRealPath,$_EXTKEY,$newNamePath);
  	    }
	    }
    }
    function addTSpageDir($absPath,$relPath,$_EXTKEY){
    	$dirs = t3lib_div::get_dirs($absPath);
    	if($dirs != 'error'){
      	foreach((array)$dirs as $value) {
    	    $newAbsPath = $absPath.$value.'/';
    	    $newRealPath = $relPath.$value.'/';
    			$files = t3lib_div::getFilesInDir($newAbsPath);
    			if(in_array('config.txt',$files)){
    				t3lib_extMgm::addPageTSConfig('<INCLUDE_TYPOSCRIPT: source="FILE:EXT:' . $_EXTKEY . '/configuration/TSpage/'.$newRealPath.'config.txt">');
          }
  		  	t3s_library_configuration::addTSpageDir($newAbsPath,$newRealPath,$_EXTKEY);
  	    }
	    }
    }
    function addTSuserDir($absPath,$relPath,$_EXTKEY){
    	$dirs = t3lib_div::get_dirs($absPath);
    	if($dirs != 'error'){
      	foreach((array)$dirs as $value) {
    	    $newAbsPath = $absPath.$value.'/';
    	    $newRealPath = $relPath.$value.'/';
    			$files = t3lib_div::getFilesInDir($newAbsPath);
    			if(in_array('config.txt',$files)){
    				t3lib_extMgm::addPageTSConfig('<INCLUDE_TYPOSCRIPT: source="FILE:EXT:' . $_EXTKEY . '/configuration/TSuser/'.$newRealPath.'config.txt">');
          }
  		  	t3s_library_configuration::addTSuserDir($newAbsPath,$newRealPath,$_EXTKEY);
  	    }
	    }
    }
    function addLocalconfDir($absPath,&$pathArray){
    	$dirs = t3lib_div::get_dirs($absPath);
    	if($dirs != 'error'){
      	foreach((array)$dirs as $value) {
  	      $newAbsPath = $absPath.$value.'/';
  			 $files = t3lib_div::getFilesInDir($newAbsPath);
    			 if(in_array('localconf.php',$files)){
    				 $pathArray[] = $newAbsPath.'localconf.php';
    			 }
  		  	t3s_library_configuration::addLocalconfDir($newAbsPath,$pathArray);
  	    }
	    }
    }
   function writeFile($absPath,$file,$content){
			if($fd = fopen($absPath.$file,'wb'))	{
			  fwrite( $fd, $content);
			  fclose( $fd );
			}  
   }
   function writeTempTS($absPath,$includeTSconfigPath,$tempTSPath,$addSetup,$addConstants){
     require_once($absPath.$includeTSconfigPath); 
     foreach((array)$includeTSconfig as $value){
       $setup .= file_get_contents($absPath.$value.'setup.txt');
       $constants .= file_get_contents($absPath.$value.'constants.txt');
     }
     $setup .= $addSetup;
     $constants .= $addConstants;
     t3s_library_configuration::writeFile($absPath.$tempTSPath,'setup.txt',$setup);
     t3s_library_configuration::writeFile($absPath.$tempTSPath,'constants.txt',$constants);
   }
}
?>
