<?php
/***************************************************************
*  Copyright notice
*
*  (c) 2007  <>
*  All rights reserved
*
*  This script is part of the TYPO3 project. The TYPO3 project is
*  free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
*
*  The GNU General Public License can be found at
*  http://www.gnu.org/copyleft/gpl.html.
*
*  This script is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*  GNU General Public License for more details.
*
*  This copyright notice MUST APPEAR in all copies of the script!
***************************************************************/

	// DEFAULT initialization of a module [BEGIN]
echo 'Wait for the next Verison of T3S! Or remove the PHP-die Function';
die();
set_time_limit(0);
unset($MCONF);
require_once('conf.php');
require_once($BACK_PATH.'init.php');
require_once($BACK_PATH.'template.php');

$LANG->includeLLFile('EXT:t3s/mod1/locallang.xml');
require_once(PATH_t3lib.'class.t3lib_scbase.php');
require_once (PATH_t3lib.'class.t3lib_install.php');
#require_once (PATH_t3lib.'class.t3lib_extfilefunctions.php');
$BE_USER->modAccess($MCONF,1);	// This checks permissions and exits if the users has no permission for entry.
	// DEFAULT initialization of a module [END]

require_once(t3lib_extMgm::extPath('t3s').'library/class.t3s_create_extension.php');
require_once(t3lib_extMgm::extPath('t3s').'library/class.t3s_insertsqlfile.php');
require_once(t3lib_extMgm::extPath('t3s').'library/class.t3s_packeges.php');
require_once(t3lib_extMgm::extPath('t3s').'library/class.t3s_terimport.php');
require_once(t3lib_extMgm::extPath('install').'mod/class.tx_install.php');
/**
 * Module 't3s install' for the 't3s' extension.
 *
 * @author	 <>
 * @package	TYPO3
 * @subpackage	tx_t3s
 */
 #set_time_limit(900);



class  tx_t3s_module1 extends t3lib_SCbase {
				var $pageinfo;
				function writeNewExtensionList($addExtList,$writeLines = array())	{
					global $TYPO3_CONF_VARS;
                    $newExtList = $TYPO3_CONF_VARS['EXT']['extList'].','.$addExtList;
					// Instance of install tool
					$instObj =t3lib_div::makeInstance('t3lib_install');
					$instObj->allowUpdateLocalConf =1;
					$instObj->updateIdentity = 'TYPO3 Extension Manager';

					// Get lines from localconf file
					$lines = $instObj->writeToLocalconf_control();
					$instObj->setValueInLocalconfFile($lines, '$TYPO3_CONF_VARS[\'EXT\'][\'extList\']', $newExtList);

					foreach((array)$writeLines as $value){
						$instObj->setValueInLocalconfFile($lines,$value['array'], $value['value']);
					}
					$instObj->writeToLocalconf_control($lines);

					$TYPO3_CONF_VARS['EXT']['extList'] = $newExtList;
					$this->removeCacheFiles();
				}
				function removeCacheFiles()	{
					return t3lib_extMgm::removeCacheFiles();
				}
				/**
				 * Initializes the Module
				 * @return	void
				 */
				function init()	{
					global $BE_USER,$LANG,$BACK_PATH,$TCA_DESCR,$TCA,$CLIENT,$TYPO3_CONF_VARS;

					parent::init();

					/*
					if (t3lib_div::_GP('clear_all_cache'))	{
						$this->include_once[] = PATH_t3lib.'class.t3lib_tcemain.php';
					}
					*/
				}
               function writeFileadmin(){
               	    $source = 'typo3conf/ext/t3s/t3sinstall/t3simages';
               	    $dest = 'fileadmin/t3simages';
               	 	$t3s_packeges = t3lib_div::makeInstance('t3s_packeges');
					$t3s_packeges->main(PATH_site,$source,$dest);
               }
                function writeHtaccess(){
                     copy(PATH_site.'typo3conf/ext/t3s/t3sinstall/_.htaccess',PATH_site.'.htaccess');
               }
               function writePackeges($extKey){
               	 $packeges = t3lib_div::get_dirs(t3lib_extMgm::extPath($extKey));
               	 $basePath = PATH_site.'typo3conf/ext';
               	 foreach($packeges as $pack){
               	 	$t3s_packeges = t3lib_div::makeInstance('t3s_packeges');
					$t3s_packeges->main($basePath, '/'.$extKey.'/'.$pack,'/'. $pack);
               	 }
               }
               function getT3sPackages(){
                	global $TYPO3_LOADED_EXT;
                	$t3sps = array();
                	foreach($TYPO3_LOADED_EXT as $key => $value){
                		if(substr($key,0,4)=='t3sp'){
                			$t3sps[] = $key;
                		}
                	}
                	return implode(',',$t3sps);
               }
				/**
				 * Main function of the module. Write the content to $this->content
				 * If you chose "web" as main module, you will need to consider the $this->id parameter which will contain the uid-number of the page clicked in the page tree
				 *
				 * @return	[type]		...
				 */
				function main()	{
					global $BE_USER,$LANG,$BACK_PATH,$TCA_DESCR,$TCA,$CLIENT,$TYPO3_CONF_VARS;
					// Access check!


					// The page will show only if there is a valid page and if this page may be viewed by the user
					$this->pageinfo = t3lib_BEfunc::readPageAccess($this->id,$this->perms_clause);
					$access = is_array($this->pageinfo) ? 1 : 0;
					if ((($this->id && $access) || ($BE_USER->user['admin'] && !$this->id))
					AND
					!$this->isInstalled()
					AND
					!(boolean)strlen($_POST['data']['submit'])
					)	{
                        $this->buildForm();
					}else  {
						if(strlen($_POST['data']['submit'])){
							$this->writeHtaccess();
							if(strlen(trim($_POST['data']['extensionnames']))){
								$this->createExtension(trim($_POST['data']['extensionnames']));
								$this->writeNewExtensionList((string)'t3s'.trim($_POST['data']['extensionnames']));
							}
							if(strlen($_POST['data']['sql'])){
								$this->installSQL();
								$this->writeFileadmin();
							}
							if(strlen($_POST['data']['terimport'])){
								$this->terImport($_POST['data']['terimport']);
								$this->writeLocalconf();
							}
							t3s_insertsqlfile::writeFile(t3lib_extMgm::extPath('t3s'));

						}
                         $this->noAccess();
					}
				}
				function installPackages(){
					$packages = $this->getPackagesNames();
                    foreach((array)$packages as $extKey){
                    	 $this->writePackeges($extKey);
                    	 $this->writeLocalconf($extKey);
                    }
				}
				function writeLocalconf(){
                    $path = t3lib_extMgm::extPath('t3s').'t3sinstall/write_localconf.php';
					if(file_exists($path)){
					     require_once($path);
	                     $this->writeNewExtensionList((string)$addExtList,(array)$writeLocalconf);
					}
				}
				function getPackagesNames(){
					  $array = explode(',',$_POST['data']['packages']);
					  foreach((array)$array as $key => $value){
					  	if(t3lib_extMgm::isLoaded(trim($value))){
					  		$packageNames[] = trim($value);
					  	}
					  }
					  return $packageNames;
				}
                function isInstalled(){
                	return (boolean)strlen(trim(@file_get_contents(t3lib_extMgm::extPath('t3s').'do_not_remove.txt')));
                }
                function installSQL(){
				   $t3sInsertSqlFile =array(
				  'sys_template' => 'sql/sys_template/default.sql',
				  'pages' => 'sql/pages/default.sql',
				  'pages_language_overlay' => 'sql/pages_language_overlay/default.sql',
				  'sys_language' => 'sql/sys_language/default.sql',
				  'tt_content' => 'sql/tt_content/default.sql',
				  );
				  $sqlFile = array();
				  foreach($t3sInsertSqlFile as $key => $value){
				  	if($this->isEmptyNotTable($key)){
				  		$GLOBALS['TYPO3_DB']->sql_query('ALTER TABLE '.$key.' RENAME '.$this->getNewTableName('T3S'.$key).';');
				  	}
				  	$sqlFile[$key] = $value;
				  }

				  t3s_insertsqlfile::sqlfile(t3lib_extMgm::extPath('t3s'),$sqlFile);

                }
                function getNewTableName($key){
                	$key = 'backup'.$key;
                	if($this->isEmptyNotTable($key)){
                		$key = $this->getNewTableName($key);
                	}
                	return $key;
                }
				function isEmptyNotTable($table){
					$querySelection['select'] = '*';
					$querySelection['table'] = $table;
					$querySelection['where'] = '';
					$querySelection['groupBy'] = '';
					$querySelection['orderBy'] = '';
					$querySelection['limit'] = '2';
			       return  $this->isSelectAble($querySelection);
				}
				function isSelectAble($query) {
					$res = $GLOBALS['TYPO3_DB']->exec_SELECTquery($query['select'],
																      $query['table'],
																	  $query['where'],
																	  $query['groupBy'],
																	  $query['orderBy'],
																	  $query['limit']);
					$rows = array ();
					while ($row = @$GLOBALS['TYPO3_DB']->sql_fetch_assoc($res)) {
						$rows[] = $row;
					}
					@$GLOBALS['TYPO3_DB']->sql_free_result($res);
					return (boolean) count($rows);
				}
				/**
				 * Prints out the module HTML
				 *
				 * @return	void
				 */
				function printContent()	{
					$this->content.=$this->doc->endPage();
					echo $this->content;
				}
				function createExtension($extName){
                    $replaceFileContent[] =  array('search'=>'setup.txt','replace'=>'/t3s/t3sinstall/setup.txt');
                    $replaceFileContent[] =  array('search'=>'constants.txt','replace'=>'/t3s/t3sinstall/constants.txt');
                    $replaceFileContent[] =  array('search'=>'config.txt','replace'=>'/t3s/t3sinstall/constants.txt');
					$excludeDir = array();
					$excludeDir[] = '/t3s/library';
					$excludeDir[] = '/t3s/sql';
					$excludeDir[] = '/t3s/t3sinstall';
                    $excludeDir[] = '/t3s/mod1';
					$changeFile = array();
					$changeFile[] = array('search'=>'/t3s/ext_tables.php','replace'=>'/t3s/t3sinstall/ext_tables.php');
					$changeFile[] = array('search'=>'/t3s/ext_localconf.php','replace'=>'/t3s/t3sinstall/ext_localconf.php');
					$changeFile[] = array('search'=>'/t3s/ext_localconf.php','replace'=>'/t3s/t3sinstall/tables.sql');

					$config['basePath'] = PATH_site.'typo3conf/ext';
					$config['sourceFolder'] = '/t3s';
					$config['destFolder'] = '/t3s'.$extName;
					$config['searchInFile'] = 't3s';
					$config['replaceInFile'] = 't3s'.$extName;
					$config['excludeDir'] = $excludeDir;
					$config['changeFile'] = $changeFile;
					$t3sCE = t3lib_div::makeInstance('t3s_create_extension');
					$t3sCE->main($config,$replaceFileContent);
				}
                function buildForm(){
					global $BE_USER,$LANG,$BACK_PATH,$TCA_DESCR,$TCA,$CLIENT,$TYPO3_CONF_VARS;
							// Draw the header.
						$this->doc = t3lib_div::makeInstance('mediumDoc');
						$this->doc->backPath = $BACK_PATH;
						$this->doc->form='<form action="" method="POST">';
							// JavaScript
					$this->doc->JScode = '
							<script language="javascript" type="text/javascript">
								script_ended = 0;
								function jumpToUrl(URL)	{
									document.location = URL;
								}
							</script>
						';
						$this->doc->postCode='
							<script language="javascript" type="text/javascript">
								script_ended = 1;
								if (top.fsMod) top.fsMod.recentIds["web"] = 0;
							</script>
						';

						$headerSection = $this->doc->getHeader('pages',$this->pageinfo,$this->pageinfo['_thePath']).'<br />'.$LANG->sL('LLL:EXT:lang/locallang_core.xml:labels.path').': '.t3lib_div::fixed_lgd_pre($this->pageinfo['_thePath'],50);

						$this->content.=$this->doc->startPage($LANG->getLL('title'));
						$this->content.=$this->doc->header($LANG->getLL('title'));
						$this->content.=$this->doc->spacer(5);

				$this->content.=$this->doc->divider(5);
		$this->content.=$this->doc->section('','
             <table border=1><tr><td>T3S Extension Name: </td><td><input type="text" name="data[extensionnames]" value="newConfigAndLayoutLibraryName"  size=50 /></td><td>Die  T3S-Konfigurations-Bibliothek wird mittels einer eigenen  Konfigurations-Bibliothek ueberschrieben und erweitert. Hier sollte man den Projektnamen waehlen!</td></tr>
            <tr><td>SQL anlegen: </td><td><input type="checkbox" name="data[sql]" checked="checked" /></td><td>Hier wird die Datenbank mittels SQL fuer die Standart-Portalvorlage voreingerichtet.</td>
			<tr><td>Extensions runterladen: </td><td><textarea type="text" name="data[terimport]"  cols="35" rows="20" />'.file_get_contents(t3lib_extMgm::extPath('t3s').'t3sinstall/terimport.txt').'</textarea></td><td>  Das kann etwas dauern! Bis zu 20 Minuten!!!!!!!!!!!!!!!</td></tr>
			<tr><td></td><td><input type="submit" name="data[submit]" value="T3S Setup aufrufen und Extension Erweiterung erstellen"/></td><td></td></tr></table>
     ');



						// ShortCut
						if ($BE_USER->mayMakeShortcut())	{
							$this->content.=$this->doc->spacer(20).$this->doc->section('',$this->doc->makeShortcutIcon('id',implode(',',array_keys($this->MOD_MENU)),$this->MCONF['name']));
						}

						$this->content.=$this->doc->spacer(10);
                }
                function noAccess(){
                	 global $BE_USER,$LANG,$BACK_PATH,$TCA_DESCR,$TCA,$CLIENT,$TYPO3_CONF_VARS;
 							// If no access or if ID == zero

						$this->doc = t3lib_div::makeInstance('mediumDoc');
						$this->doc->backPath = $BACK_PATH;

						$this->content.=$this->doc->startPage($LANG->getLL('title'));
						$this->content.=$this->doc->header($LANG->getLL('title'));
						$this->content.=$this->doc->spacer(5);
						$this->content.=$this->doc->spacer(10);
						$this->content.=$this->doc->section('','T3S is installed');
                }
                function getFileContent($extKey,$file){
  					$path = t3lib_extMgm::extPath($extKey).$file;
					if(file_exists($path)){
					     return file_get_contents($path);
					}
					return '';
               }
				function terImport($t3sExtensions){
					$SOBE = t3lib_div::makeInstance('t3s_terimport');
					$SOBE->init();
					foreach($SOBE->include_once as $INC_FILE) {
						include_once($INC_FILE);
					}
					$SOBE->checkExtObj();
					$SOBE->main($t3sExtensions);
				}


}



if (defined('TYPO3_MODE') && $TYPO3_CONF_VARS[TYPO3_MODE]['XCLASS']['ext/t3s/mod1/index.php'])	{
	include_once($TYPO3_CONF_VARS[TYPO3_MODE]['XCLASS']['ext/t3s/mod1/index.php']);
}




// Make instance:
$SOBE = t3lib_div::makeInstance('tx_t3s_module1');
$SOBE->init();

// Include files?
foreach($SOBE->include_once as $INC_FILE)	include_once($INC_FILE);

$SOBE->main();
$SOBE->printContent();


?>