<?php

class t3s_packeges{
	function main($basePath, $source, $dest){
		$this->dircpy($basePath, $source,$dest); //recurse!
	}
	function dircpy($basePath, $source, $dest, $overwrite = false){
	    if(!is_dir($basePath . $dest)) //Lets just make sure our new folder is already created. Alright so its not efficient to check each time... bite me
	    mkdir($basePath . $dest);
	    if($handle = opendir($basePath . $source)){        // if the folder exploration is sucsessful, continue
	        while(false !== ($file = readdir($handle))){ // as long as storing the next file to $file is successful, continue
	            if($file != '.' && $file != '..'){
	                $path = $source . '/' . $file;
	                if(is_file($basePath . $path)){
	                    if(!is_file($basePath . $dest . '/' . $file) || $overwrite)
	                    if(!@copy($basePath . $path, $basePath . $dest . '/' . $file)){
	                        echo '<font color="red">File ('.$path.') could not be copied, likely a permissions problem.</font>';
	                    }
	                } elseif(is_dir($basePath . $path)){
	                    if(!is_dir($basePath . $dest . '/' . $file))
	                    mkdir($basePath . $dest . '/' . $file); // make subdirectory before subdirectory is copied
	                    $this->dircpy($basePath, $path, $dest . '/' . $file, $overwrite); //recurse!
	                }
	            }
	        }
	        closedir($handle);
	    }
	}
}
?>