DROP TABLE IF EXISTS pages;
CREATE TABLE pages (
  uid int(11) NOT NULL auto_increment,
  pid int(11) default '0' NOT NULL ,
  t3ver_oid int(11) default '0' NOT NULL ,
  t3ver_id int(11) default '0' NOT NULL ,
  t3ver_wsid int(11) default '0' NOT NULL ,
  t3ver_label varchar(30) default '' NOT NULL ,
  t3ver_state tinyint(4) default '0' NOT NULL ,
  t3ver_stage tinyint(4) default '0' NOT NULL ,
  t3ver_count int(11) default '0' NOT NULL ,
  t3ver_tstamp int(11) default '0' NOT NULL ,
  t3ver_swapmode tinyint(4) default '0' NOT NULL ,
  t3_origuid int(11) default '0' NOT NULL ,
  tstamp int(11) unsigned default '0' NOT NULL ,
  sorting int(11) unsigned default '0' NOT NULL ,
  deleted tinyint(1) unsigned default '0' NOT NULL ,
  perms_userid int(11) unsigned default '0' NOT NULL ,
  perms_groupid int(11) unsigned default '0' NOT NULL ,
  perms_user tinyint(4) unsigned default '0' NOT NULL ,
  perms_group tinyint(4) unsigned default '0' NOT NULL ,
  perms_everybody tinyint(4) unsigned default '0' NOT NULL ,
  editlock tinyint(4) unsigned default '0' NOT NULL ,
  crdate int(11) unsigned default '0' NOT NULL ,
  cruser_id int(11) unsigned default '0' NOT NULL ,
  title tinytext NOT NULL,
  doktype tinyint(3) unsigned default '0' NOT NULL ,
  TSconfig text NOT NULL,
  storage_pid int(11) default '0' NOT NULL ,
  is_siteroot tinyint(4) default '0' NOT NULL ,
  php_tree_stop tinyint(4) default '0' NOT NULL ,
  tx_impexp_origuid int(11) default '0' NOT NULL ,
  url tinytext NOT NULL,
  hidden tinyint(4) unsigned default '0' NOT NULL ,
  starttime int(11) unsigned default '0' NOT NULL ,
  endtime int(11) unsigned default '0' NOT NULL ,
  urltype tinyint(4) unsigned default '0' NOT NULL ,
  shortcut int(10) unsigned default '0' NOT NULL ,
  shortcut_mode int(10) unsigned default '0' NOT NULL ,
  no_cache int(10) unsigned default '0' NOT NULL ,
  fe_group varchar(100) default '0' NOT NULL ,
  subtitle tinytext NOT NULL,
  layout tinyint(3) unsigned default '0' NOT NULL ,
  target varchar(20) default '' NOT NULL ,
  media blob NOT NULL,
  lastUpdated int(10) unsigned default '0' NOT NULL ,
  keywords text NOT NULL,
  cache_timeout int(10) unsigned default '0' NOT NULL ,
  newUntil int(10) unsigned default '0' NOT NULL ,
  description text NOT NULL,
  no_search tinyint(3) unsigned default '0' NOT NULL ,
  SYS_LASTCHANGED int(10) unsigned default '0' NOT NULL ,
  abstract text NOT NULL,
  module varchar(10) default '' NOT NULL ,
  extendToSubpages tinyint(3) unsigned default '0' NOT NULL ,
  author tinytext NOT NULL,
  author_email varchar(80) default '' NOT NULL ,
  nav_title tinytext NOT NULL,
  nav_hide tinyint(4) default '0' NOT NULL ,
  content_from_pid int(10) unsigned default '0' NOT NULL ,
  mount_pid int(10) unsigned default '0' NOT NULL ,
  mount_pid_ol tinyint(4) default '0' NOT NULL ,
  alias varchar(32) default '' NOT NULL ,
  l18n_cfg tinyint(4) default '0' NOT NULL ,
  fe_login_mode tinyint(4) default '0' NOT NULL ,
  tx_realurl_pathsegment varchar(30) default '' NOT NULL ,
  tx_rlmptmplselector_main_tmpl varchar(240) default '' NOT NULL ,
  tx_rlmptmplselector_ca_tmpl varchar(240) default '' NOT NULL ,
  PRIMARY KEY  (uid),
  KEY t3ver_oid (t3ver_oid,t3ver_wsid),
  KEY parent (pid,sorting),
  KEY alias (alias)
);



INSERT INTO pages VALUES (1, 0, 0, 0, 0, '', 0, 0, 0, 0, 0, 0, 1193917604, 256, 0, 1, 0, 31, 27, 0, 0, 1174935916, 1, 'Home', 2, '', 0, 0, 0, 0, '', 0, 0, 0, 1, 2, 1, 0, '', '', 0, '', '', 0, '', 0, 0, '', 0, 1193917604, '', '', 0, '', '', '', 0, 0, 0, 0, '', 0, 0, '', 'four-boxes.html', 'two-boxes.html');
INSERT INTO pages VALUES (2, 1, 0, 0, 0, '', 0, 0, 0, 0, 0, 0, 1176658596, 256, 0, 1, 0, 31, 27, 0, 0, 1174935975, 1, 'News', 2, '', 0, 0, 0, 0, '', 0, 0, 0, 1, 0, 0, 0, '', '', 0, '', '', 0, '', 0, 0, '', 0, 1176836150, '', '', 0, '', '', '', 0, 0, 0, 0, '', 0, 0, '', '0', '0');
INSERT INTO pages VALUES (3, 1, 0, 0, 0, '', 0, 0, 0, 0, 0, 0, 1179621587, 512, 0, 1, 0, 31, 27, 0, 0, 1174935994, 1, 'Gallery', 2, '', 0, 0, 0, 0, '', 0, 0, 0, 1, 0, 0, 0, '', '', 0, '', '', 0, '', 0, 0, '', 0, 1179621587, '', '', 0, '', '', '', 0, 18, 0, 0, '', 0, 0, '', '0', '0');
INSERT INTO pages VALUES (4, 1, 0, 0, 0, '', 0, 0, 0, 0, 0, 0, 1176567736, 768, 0, 1, 0, 31, 27, 0, 0, 1174936008, 1, 'Forum', 1, '', 0, 0, 0, 0, '', 0, 0, 0, 1, 0, 0, 0, '', '', 0, '', '', 0, '', 0, 0, '', 0, 1176567885, '', '', 0, '', '', '', 0, 0, 0, 0, '', 0, 0, '', '0', '0');
INSERT INTO pages VALUES (5, 1, 0, 0, 0, '', 0, 0, 0, 0, 0, 0, 1179623395, 1024, 0, 1, 0, 31, 27, 0, 0, 1174936187, 1, 'Blog', 2, '', 0, 0, 0, 0, '', 0, 0, 0, 1, 0, 0, 0, '', '', 0, '', '', 0, '', 0, 0, '', 0, 1179624214, '', '', 0, '', '', '', 0, 12, 0, 0, '', 0, 0, '', '0', '0');
INSERT INTO pages VALUES (6, 1, 0, 0, 0, '', 0, 0, 0, 0, 0, 0, 1174936223, 1280, 0, 1, 0, 31, 27, 0, 0, 1174936223, 1, 'Downloads', 1, '', 0, 0, 0, 0, '', 0, 0, 0, 1, 0, 0, 0, '', '', 0, '', '', 0, '', 0, 0, '', 0, 1174936223, '', '', 0, '', '', '', 0, 0, 0, 0, '', 0, 0, '', '', '');
INSERT INTO pages VALUES (7, 1, 0, 0, 0, '', 0, 0, 0, 0, 0, 0, 1176562711, 1536, 0, 1, 0, 31, 27, 0, 0, 1174936284, 1, 'Modules', 254, '', 0, 0, 0, 0, '', 0, 0, 0, 1, 0, 0, 0, '', '', 0, '', '', 0, '', 0, 0, '', 0, 0, '', '', 0, '', '', '', 0, 0, 0, 0, '', 0, 0, '', '0', '0');
INSERT INTO pages VALUES (8, 7, 0, 0, 0, '', 0, 0, 0, 0, 0, 0, 1174936330, 256, 0, 1, 0, 31, 27, 0, 0, 1174936314, 1, 'timtab', 5, '', 0, 0, 0, 0, '', 0, 0, 0, 1, 0, 0, 0, '', '', 0, '', '', 0, '', 0, 0, '', 0, 0, '', '', 0, '', '', '', 0, 0, 0, 0, '', 0, 0, '', '', '');
INSERT INTO pages VALUES (9, 7, 0, 0, 0, '', 0, 0, 0, 0, 0, 0, 1174936343, 512, 0, 1, 0, 31, 27, 0, 0, 1174936343, 1, 'tt_news', 5, '', 0, 0, 0, 0, '', 0, 0, 0, 1, 0, 0, 0, '', '', 0, '', '', 0, '', 0, 0, '', 0, 0, '', '', 0, '', '', '', 0, 0, 0, 0, '', 0, 0, '', '', '');
INSERT INTO pages VALUES (10, 7, 0, 0, 0, '', 0, 0, 0, 0, 0, 0, 1174936400, 768, 0, 1, 0, 31, 27, 0, 0, 1174936400, 1, 'dam_downloadlist', 5, '', 0, 0, 0, 0, '', 0, 0, 0, 1, 0, 0, 0, '', '', 0, '', '', 0, '', 0, 0, '', 0, 0, '', '', 0, '', '', '', 0, 0, 0, 0, '', 0, 0, '', '', '');
INSERT INTO pages VALUES (11, 7, 0, 0, 0, '', 0, 0, 0, 0, 0, 0, 1174936634, 1024, 0, 1, 0, 31, 27, 0, 0, 1174936431, 1, 'dam_gallery', 5, '', 0, 0, 0, 0, '', 0, 0, 0, 1, 0, 0, 0, '', '', 0, '', '', 0, '', 0, 0, '', 0, 0, '', '', 0, '', '', '', 0, 0, 0, 0, '', 0, 0, '', '', '');
INSERT INTO pages VALUES (12, 9, 0, 0, 0, '', 0, 0, 0, 0, 0, 0, 1174936805, 256, 0, 1, 0, 31, 27, 0, 0, 1174936455, 1, 'News', 1, '', 0, 0, 0, 0, '', 0, 0, 0, 1, 0, 0, 0, '', '', 0, '', '', 0, '', 0, 0, '', 0, 0, '', '', 0, '', '', '', 0, 0, 0, 0, '', 0, 0, '', '', '');
INSERT INTO pages VALUES (13, 12, 0, 0, 0, '', 0, 0, 0, 0, 0, 0, 1174936813, 256, 0, 1, 0, 31, 27, 0, 0, 1174936472, 1, 'Article', 1, '', 0, 0, 0, 0, '', 0, 0, 0, 1, 0, 0, 0, '', '', 0, '', '', 0, '', 0, 0, '', 0, 0, '', '', 0, '', '', '', 0, 0, 0, 0, '', 0, 0, '', '', '');
INSERT INTO pages VALUES (14, 12, 0, 0, 0, '', 0, 0, 0, 0, 0, 0, 1174936819, 512, 0, 1, 0, 31, 27, 0, 0, 1174936485, 1, 'Archiv', 1, '', 0, 0, 0, 0, '', 0, 0, 0, 1, 0, 0, 0, '', '', 0, '', '', 0, '', 0, 0, '', 0, 0, '', '', 0, '', '', '', 0, 0, 0, 0, '', 0, 0, '', '', '');
INSERT INTO pages VALUES (15, 7, 0, 0, 0, '', 0, 0, 0, 0, 0, 0, 1174936568, 1280, 0, 1, 0, 31, 27, 0, 0, 1174936568, 1, 'tt_address', 5, '', 0, 0, 0, 0, '', 0, 0, 0, 1, 0, 0, 0, '', '', 0, '', '', 0, '', 0, 0, '', 0, 0, '', '', 0, '', '', '', 0, 0, 0, 0, '', 0, 0, '', '', '');
INSERT INTO pages VALUES (16, 15, 0, 0, 0, '', 0, 0, 0, 0, 0, 0, 1174936852, 256, 0, 1, 0, 31, 27, 0, 0, 1174936598, 1, 'Address List', 1, '', 0, 0, 0, 0, '', 0, 0, 0, 1, 0, 0, 0, '', '', 0, '', '', 0, '', 0, 0, '', 0, 0, '', '', 0, '', '', '', 0, 0, 0, 0, '', 0, 0, '', '', '');
INSERT INTO pages VALUES (17, 16, 0, 0, 0, '', 0, 0, 0, 0, 0, 0, 1174936869, 256, 0, 1, 0, 31, 27, 0, 0, 1174936619, 1, 'Address Details', 1, '', 0, 0, 0, 0, '', 0, 0, 0, 1, 0, 0, 0, '', '', 0, '', '', 0, '', 0, 0, '', 0, 0, '', '', 0, '', '', '', 0, 0, 0, 0, '', 0, 0, '', '', '');
INSERT INTO pages VALUES (18, 11, 0, 0, 0, '', 0, 0, 0, 0, 0, 0, 1179621167, 256, 0, 1, 0, 31, 27, 0, 0, 1174936670, 1, 'ce_gallery', 1, '', 0, 0, 0, 0, '', 0, 0, 0, 1, 0, 0, 0, '', '', 0, '', '', 0, '', 0, 0, '', 0, 1179621367, '', '', 0, '', '', '', 0, 0, 0, 0, '', 0, 0, '', '0', '0');
INSERT INTO pages VALUES (19, 10, 0, 0, 0, '', 0, 0, 0, 0, 0, 0, 1174936791, 256, 0, 1, 0, 31, 27, 0, 0, 1174936791, 1, 'Download Browser', 1, '', 0, 0, 0, 0, '', 0, 0, 0, 1, 0, 0, 0, '', '', 0, '', '', 0, '', 0, 0, '', 0, 0, '', '', 0, '', '', '', 0, 0, 0, 0, '', 0, 0, '', '', '');
INSERT INTO pages VALUES (20, 7, 0, 0, 0, '', 0, 0, 0, 0, 0, 0, 1174936896, 1536, 0, 1, 0, 31, 27, 0, 0, 1174936896, 1, 'faq', 5, '', 0, 0, 0, 0, '', 0, 0, 0, 1, 0, 0, 0, '', '', 0, '', '', 0, '', 0, 0, '', 0, 0, '', '', 0, '', '', '', 0, 0, 0, 0, '', 0, 0, '', '', '');
INSERT INTO pages VALUES (21, 7, 0, 0, 0, '', 0, 0, 0, 0, 0, 0, 1174941533, 1792, 0, 1, 0, 31, 27, 0, 0, 1174936927, 1, 'sb_akronymmanager', 5, '', 0, 0, 0, 0, '', 0, 0, 0, 1, 0, 0, 0, '', '', 0, '', '', 0, '', 0, 0, '', 0, 0, '', '', 0, '', '', '', 0, 0, 0, 0, '', 0, 0, '', '', '');
INSERT INTO pages VALUES (22, 21, 0, 0, 0, '', 0, 0, 0, 0, 0, 0, 1174936960, 256, 0, 1, 0, 31, 27, 0, 0, 1174936960, 1, 'Glossar List', 1, '', 0, 0, 0, 0, '', 0, 0, 0, 1, 0, 0, 0, '', '', 0, '', '', 0, '', 0, 0, '', 0, 0, '', '', 0, '', '', '', 0, 0, 0, 0, '', 0, 0, '', '', '');
INSERT INTO pages VALUES (23, 7, 0, 0, 0, '', 0, 0, 0, 0, 0, 0, 1174938184, 2048, 0, 1, 0, 31, 27, 0, 0, 1174937024, 1, 'sr_feuser_register', 5, '', 0, 0, 0, 0, '', 0, 0, 0, 1, 0, 0, 0, '', '', 0, '', '', 0, '', 0, 0, '', 0, 0, '', '', 0, '', '', '', 0, 0, 0, 0, '', 0, 0, '', '', '');
INSERT INTO pages VALUES (24, 7, 0, 0, 0, '', 0, 0, 0, 0, 0, 0, 1174937053, 2304, 0, 1, 0, 31, 27, 0, 0, 1174937053, 1, 'newloginbox', 5, '', 0, 0, 0, 0, '', 0, 0, 0, 1, 0, 0, 0, '', '', 0, '', '', 0, '', 0, 0, '', 0, 0, '', '', 0, '', '', '', 0, 0, 0, 0, '', 0, 0, '', '', '');
INSERT INTO pages VALUES (25, 7, 0, 0, 0, '', 0, 0, 0, 0, 0, 0, 1174937074, 2560, 0, 1, 0, 31, 27, 0, 0, 1174937074, 1, 'chc_forum', 5, '', 0, 0, 0, 0, '', 0, 0, 0, 1, 0, 0, 0, '', '', 0, '', '', 0, '', 0, 0, '', 0, 0, '', '', 0, '', '', '', 0, 0, 0, 0, '', 0, 0, '', '', '');
INSERT INTO pages VALUES (26, 7, 0, 0, 0, '', 0, 0, 0, 0, 0, 0, 1174937113, 2816, 0, 1, 0, 31, 27, 0, 0, 1174937107, 1, 'jw_calendar', 5, '', 0, 0, 0, 0, '', 0, 0, 0, 1, 0, 0, 0, '', '', 0, '', '', 0, '', 0, 0, '', 0, 0, '', '', 0, '', '', '', 0, 0, 0, 0, '', 0, 0, '', '', '');
INSERT INTO pages VALUES (27, 1, 0, 0, 0, '', 0, 0, 0, 0, 0, 0, 1174937170, 1408, 0, 1, 0, 31, 27, 0, 0, 1174937170, 1, 'Login', 1, '', 0, 0, 0, 0, '', 0, 0, 0, 1, 0, 0, 0, '', '', 0, '', '', 0, '', 0, 0, '', 0, 1174937170, '', '', 0, '', '', '', 0, 0, 0, 0, '', 0, 0, '', '', '');
INSERT INTO pages VALUES (28, 27, 0, 0, 0, '', 0, 0, 0, 0, 0, 0, 1174937203, 256, 0, 1, 0, 31, 27, 0, 0, 1174937203, 1, 'Registration', 1, '', 0, 0, 0, 0, '', 0, 0, 0, 1, 0, 0, 0, '', '', 0, '', '', 0, '', 0, 0, '', 0, 1174937203, '', '', 0, '', '', '', 0, 0, 0, 0, '', 0, 0, '', '', '');
INSERT INTO pages VALUES (29, 27, 0, 0, 0, '', 0, 0, 0, 0, 0, 0, 1174937294, 512, 0, 1, 0, 31, 27, 0, 0, 1174937294, 1, 'Secure pages', 1, '', 0, 0, 0, 0, '', 0, 0, 0, 1, 0, 0, 0, '', '', 0, '', '', 0, '', 0, 0, '', 0, 1174937294, '', '', 0, '', '', '', 0, 0, 0, 0, '', 0, 0, '', '', '');
INSERT INTO pages VALUES (30, 1, 0, 0, 0, '', 0, 0, 0, 0, 0, 0, 1174937502, 1792, 0, 1, 0, 31, 27, 0, 0, 1174937502, 1, 'Records', 254, '', 0, 0, 0, 0, '', 0, 0, 0, 1, 0, 0, 0, '', '', 0, '', '', 0, '', 0, 0, '', 0, 0, '', '', 0, '', '', '', 0, 0, 0, 0, '', 0, 0, '', '', '');
INSERT INTO pages VALUES (31, 30, 0, 0, 0, '', 0, 0, 0, 0, 0, 0, 1174937548, 256, 0, 1, 0, 31, 27, 0, 0, 1174937522, 1, 'tt_news', 254, '', 0, 0, 0, 0, '', 0, 0, 0, 1, 0, 0, 0, '', '', 0, '', '', 0, '', 0, 0, '', 0, 0, '', '', 0, '', '', '', 0, 0, 0, 0, '', 0, 0, '', '', '');
INSERT INTO pages VALUES (32, 30, 0, 0, 0, '', 0, 0, 0, 0, 0, 0, 1174937571, 512, 0, 1, 0, 31, 27, 0, 0, 1174937571, 1, 'timtab', 254, '', 0, 0, 0, 0, '', 0, 0, 0, 1, 0, 0, 0, '', '', 0, '', '', 0, '', 0, 0, '', 0, 0, '', '', 0, '', '', '', 0, 0, 0, 0, '', 0, 0, '', '', '');
INSERT INTO pages VALUES (33, 30, 0, 0, 0, '', 0, 0, 0, 0, 0, 0, 1174937589, 768, 0, 1, 0, 31, 27, 0, 0, 1174937589, 1, 'dam', 254, '', 0, 0, 0, 0, '', 0, 0, 0, 1, 0, 0, 0, '', '', 0, '', '', 0, '', 0, 0, '', 0, 0, '', '', 0, '', '', '', 0, 0, 0, 0, '', 0, 0, '', '', '');
INSERT INTO pages VALUES (34, 30, 0, 0, 0, '', 0, 0, 0, 0, 0, 0, 1174937603, 1024, 0, 1, 0, 31, 27, 0, 0, 1174937603, 1, 'tt_address', 254, '', 0, 0, 0, 0, '', 0, 0, 0, 1, 0, 0, 0, '', '', 0, '', '', 0, '', 0, 0, '', 0, 0, '', '', 0, '', '', '', 0, 0, 0, 0, '', 0, 0, '', '', '');
INSERT INTO pages VALUES (35, 30, 0, 0, 0, '', 0, 0, 0, 0, 0, 0, 1174937682, 1280, 0, 1, 0, 31, 27, 0, 0, 1174937682, 1, 'direct_mail', 254, '', 0, 0, 0, 0, '', 0, 0, 0, 1, 0, 0, 0, '', '', 0, '', '', 0, '', 0, 0, '', 0, 0, '', '', 0, '', '', '', 0, 0, 0, 0, '', 0, 0, '', '', '');
INSERT INTO pages VALUES (36, 7, 0, 0, 0, '', 0, 0, 0, 0, 0, 0, 1174938139, 3072, 0, 1, 0, 31, 27, 0, 0, 1174938139, 1, 'indexed_search', 5, '', 0, 0, 0, 0, '', 0, 0, 0, 1, 0, 0, 0, '', '', 0, '', '', 0, '', 0, 0, '', 0, 1174938139, '', '', 0, '', '', '', 0, 0, 0, 0, '', 0, 0, '', '', '');
INSERT INTO pages VALUES (37, 30, 0, 0, 0, '', 0, 0, 0, 0, 0, 0, 1174938212, 1536, 0, 1, 0, 31, 27, 0, 0, 1174938212, 1, 'faq', 254, '', 0, 0, 0, 0, '', 0, 0, 0, 1, 0, 0, 0, '', '', 0, '', '', 0, '', 0, 0, '', 0, 0, '', '', 0, '', '', '', 0, 0, 0, 0, '', 0, 0, '', '', '');
INSERT INTO pages VALUES (38, 30, 0, 0, 0, '', 0, 0, 0, 0, 0, 0, 1174938251, 1792, 0, 1, 0, 31, 27, 0, 0, 1174938251, 1, 'glossar', 254, '', 0, 0, 0, 0, '', 0, 0, 0, 1, 0, 0, 0, '', '', 0, '', '', 0, '', 0, 0, '', 0, 0, '', '', 0, '', '', '', 0, 0, 0, 0, '', 0, 0, '', '', '');
INSERT INTO pages VALUES (39, 1, 0, 0, 0, '', 0, 0, 0, 0, 0, 0, 1176502769, 1472, 0, 1, 0, 31, 27, 0, 0, 1174938314, 1, 'Service', 1, '', 0, 0, 0, 0, '', 0, 0, 0, 1, 0, 0, 0, '', '', 0, '', '', 0, '', 0, 0, '', 0, 1176502769, '', '', 0, '', '', '', 0, 0, 0, 0, '', 0, 0, '', '0', '0');
INSERT INTO pages VALUES (40, 39, 0, 0, 0, '', 0, 0, 0, 0, 0, 0, 1174938342, 256, 0, 1, 0, 31, 27, 0, 0, 1174938342, 1, 'Impressum', 1, '', 0, 0, 0, 0, '', 0, 0, 0, 1, 0, 0, 0, '', '', 0, '', '', 0, '', 0, 0, '', 0, 1176561008, '', '', 0, '', '', '', 0, 0, 0, 0, '', 0, 0, '', '', '');
INSERT INTO pages VALUES (41, 7, 0, 0, 0, '', 0, 0, 0, 0, 0, 0, 1174938410, 128, 0, 1, 0, 31, 27, 0, 0, 1174938396, 1, 'tt_content', 5, '', 0, 0, 0, 0, '', 0, 0, 0, 1, 0, 0, 0, '', '', 0, '', '', 0, '', 0, 0, '', 0, 0, '', '', 0, '', '', '', 0, 0, 0, 0, '', 0, 0, '', '', '');
INSERT INTO pages VALUES (42, 41, 0, 0, 0, '', 0, 0, 0, 0, 0, 0, 1174938428, 256, 0, 1, 0, 31, 27, 0, 0, 1174938428, 1, 'Sidemap', 1, '', 0, 0, 0, 0, '', 0, 0, 0, 1, 0, 0, 0, '', '', 0, '', '', 0, '', 0, 0, '', 0, 0, '', '', 0, '', '', '', 0, 0, 0, 0, '', 0, 0, '', '', '');
INSERT INTO pages VALUES (43, 41, 0, 0, 0, '', 0, 0, 0, 0, 0, 0, 1174938445, 512, 0, 1, 0, 31, 27, 0, 0, 1174938445, 1, 'Download List', 1, '', 0, 0, 0, 0, '', 0, 0, 0, 1, 0, 0, 0, '', '', 0, '', '', 0, '', 0, 0, '', 0, 0, '', '', 0, '', '', '', 0, 0, 0, 0, '', 0, 0, '', '', '');
INSERT INTO pages VALUES (44, 39, 0, 0, 0, '', 0, 0, 0, 0, 0, 0, 1176568006, 512, 0, 1, 0, 31, 27, 0, 0, 1174938473, 1, 'Search', 2, '', 0, 0, 0, 0, '', 0, 0, 0, 1, 0, 0, 0, '', '', 0, '', '', 0, '', 0, 0, '', 0, 1176568006, '', '', 0, '', '', '', 0, 0, 0, 0, '', 0, 0, '', '0', '0');
INSERT INTO pages VALUES (45, 39, 0, 0, 0, '', 0, 0, 0, 0, 0, 0, 1174938494, 768, 0, 1, 0, 31, 27, 0, 0, 1174938494, 1, 'AGB', 1, '', 0, 0, 0, 0, '', 0, 0, 0, 1, 0, 0, 0, '', '', 0, '', '', 0, '', 0, 0, '', 0, 1174938494, '', '', 0, '', '', '', 0, 0, 0, 0, '', 0, 0, '', '', '');
INSERT INTO pages VALUES (46, 39, 0, 0, 0, '', 0, 0, 0, 0, 0, 0, 1174938529, 1024, 0, 1, 0, 31, 27, 0, 0, 1174938529, 1, 'Newsletter', 1, '', 0, 0, 0, 0, '', 0, 0, 0, 1, 0, 0, 0, '', '', 0, '', '', 0, '', 0, 0, '', 0, 1174938529, '', '', 0, '', '', '', 0, 0, 0, 0, '', 0, 0, '', '', '');
INSERT INTO pages VALUES (47, 30, 0, 0, 0, '', 0, 0, 0, 0, 0, 0, 1174938593, 2048, 0, 1, 0, 31, 27, 0, 0, 1174938593, 1, 'sr_feuser_register', 254, '', 0, 0, 0, 0, '', 0, 0, 0, 1, 0, 0, 0, '', '', 0, '', '', 0, '', 0, 0, '', 0, 0, '', '', 0, '', '', '', 0, 0, 0, 0, '', 0, 0, '', '', '');
INSERT INTO pages VALUES (48, 47, 0, 0, 0, '', 0, 0, 0, 0, 0, 0, 1174938614, 256, 0, 1, 0, 31, 27, 0, 0, 1174938614, 1, 'groups', 254, '', 0, 0, 0, 0, '', 0, 0, 0, 1, 0, 0, 0, '', '', 0, '', '', 0, '', 0, 0, '', 0, 0, '', '', 0, '', '', '', 0, 0, 0, 0, '', 0, 0, '', '', '');
INSERT INTO pages VALUES (49, 47, 0, 0, 0, '', 0, 0, 0, 0, 0, 0, 1174938634, 512, 0, 1, 0, 31, 27, 0, 0, 1174938634, 1, 'user', 254, '', 0, 0, 0, 0, '', 0, 0, 0, 1, 0, 0, 0, '', '', 0, '', '', 0, '', 0, 0, '', 0, 0, '', '', 0, '', '', '', 0, 0, 0, 0, '', 0, 0, '', '', '');
INSERT INTO pages VALUES (50, 35, 0, 0, 0, '', 0, 0, 0, 0, 0, 0, 1174938678, 256, 0, 1, 0, 31, 27, 0, 0, 1174938667, 1, 'newsletter_registration', 254, '', 0, 0, 0, 0, '', 0, 0, 0, 1, 0, 0, 0, '', '', 0, '', '', 0, '', 0, 0, '', 0, 0, '', '', 0, '', '', '', 0, 0, 0, 0, '', 0, 0, '', '', '');
INSERT INTO pages VALUES (51, 50, 0, 0, 0, '', 0, 0, 0, 0, 0, 0, 1174938696, 256, 0, 1, 0, 31, 27, 0, 0, 1174938692, 1, 'user', 254, '', 0, 0, 0, 0, '', 0, 0, 0, 1, 0, 0, 0, '', '', 0, '', '', 0, '', 0, 0, '', 0, 0, '', '', 0, '', '', '', 0, 0, 0, 0, '', 0, 0, '', '', '');
INSERT INTO pages VALUES (52, 50, 0, 0, 0, '', 0, 0, 0, 0, 0, 0, 1174938711, 512, 0, 1, 0, 31, 27, 0, 0, 1174938711, 1, 'groups', 254, '', 0, 0, 0, 0, '', 0, 0, 0, 1, 0, 0, 0, '', '', 0, '', '', 0, '', 0, 0, '', 0, 0, '', '', 0, '', '', '', 0, 0, 0, 0, '', 0, 0, '', '', '');
INSERT INTO pages VALUES (53, 39, 0, 0, 0, '', 0, 0, 0, 0, 0, 0, 1174938771, 1280, 0, 1, 0, 31, 27, 0, 0, 1174938771, 1, 'Contact Form', 1, '', 0, 0, 0, 0, '', 0, 0, 0, 1, 0, 0, 0, '', '', 0, '', '', 0, '', 0, 0, '', 0, 1176839028, '', '', 0, '', '', '', 0, 0, 0, 0, '', 0, 0, '', '', '');
INSERT INTO pages VALUES (54, 7, 0, 0, 0, '', 0, 0, 0, 0, 0, 0, 1174938806, 3328, 0, 1, 0, 31, 27, 0, 0, 1174938806, 1, 'mailformplus', 5, '', 0, 0, 0, 0, '', 0, 0, 0, 1, 0, 0, 0, '', '', 0, '', '', 0, '', 0, 0, '', 0, 0, '', '', 0, '', '', '', 0, 0, 0, 0, '', 0, 0, '', '', '');
INSERT INTO pages VALUES (55, 30, 0, 0, 0, '', 0, 0, 0, 0, 0, 0, 1174938845, 2304, 0, 1, 0, 31, 27, 0, 0, 1174938845, 1, 'jw_calendar', 254, '', 0, 0, 0, 0, '', 0, 0, 0, 1, 0, 0, 0, '', '', 0, '', '', 0, '', 0, 0, '', 0, 0, '', '', 0, '', '', '', 0, 0, 0, 0, '', 0, 0, '', '', '');
INSERT INTO pages VALUES (56, 30, 0, 0, 0, '', 0, 0, 0, 0, 0, 0, 1174938873, 2560, 0, 1, 0, 31, 27, 0, 0, 1174938873, 1, 'mailformplus', 254, '', 0, 0, 0, 0, '', 0, 0, 0, 1, 0, 0, 0, '', '', 0, '', '', 0, '', 0, 0, '', 0, 0, '', '', 0, '', '', '', 0, 0, 0, 0, '', 0, 0, '', '', '');
INSERT INTO pages VALUES (57, 30, 0, 0, 0, '', 0, 0, 0, 0, 0, 0, 1174938895, 2816, 0, 1, 0, 31, 27, 0, 0, 1174938895, 1, 'chc_forum', 254, '', 0, 0, 0, 0, '', 0, 0, 0, 1, 0, 0, 0, '', '', 0, '', '', 0, '', 0, 0, '', 0, 0, '', '', 0, '', '', '', 0, 0, 0, 0, '', 0, 0, '', '', '');
INSERT INTO pages VALUES (58, 0, 0, 0, 0, '', 0, 0, 0, 0, 0, 0, 1174940582, 29999, 0, 0, 0, 31, 31, 31, 0, 1174940582, 0, 'Media', 2, '', 0, 0, 0, 0, '', 0, 0, 0, 0, 0, 0, 0, '0', '', 0, '', '', 0, '', 0, 0, '', 0, 0, '', 'dam', 0, '', '', '', 0, 0, 0, 0, '', 0, 0, '', '', '');
INSERT INTO pages VALUES (59, 30, 0, 0, 0, '', 0, 0, 0, 0, 0, 0, 1174941554, 3072, 0, 1, 0, 31, 27, 0, 0, 1174941554, 1, 'sb_akronymmanager', 254, '', 0, 0, 0, 0, '', 0, 0, 0, 1, 0, 0, 0, '', '', 0, '', '', 0, '', 0, 0, '', 0, 0, '', '', 0, '', '', '', 0, 0, 0, 0, '', 0, 0, '', '', '');
INSERT INTO pages VALUES (60, 30, 0, 0, 0, '', 0, 0, 0, 0, 0, 0, 1174941606, 3328, 0, 1, 0, 31, 27, 0, 0, 1174941606, 1, 'sb_accessiblecontent', 254, '', 0, 0, 0, 0, '', 0, 0, 0, 1, 0, 0, 0, '', '', 0, '', '', 0, '', 0, 0, '', 0, 0, '', '', 0, '', '', '', 0, 0, 0, 0, '', 0, 0, '', '', '');
INSERT INTO pages VALUES (61, 31, 0, 0, 0, '', 0, 0, 0, 0, 0, 0, 1174941726, 256, 0, 1, 0, 31, 27, 0, 0, 1174941711, 1, 'news', 254, '', 0, 0, 0, 0, '', 0, 0, 0, 1, 0, 0, 0, '', '', 0, '', '', 0, '', 0, 0, '', 0, 0, '', 'news', 0, '', '', '', 0, 0, 0, 0, '', 0, 0, '', '', '');
INSERT INTO pages VALUES (62, 39, 0, 0, 0, '', 0, 0, 0, 0, 0, 0, 1176563511, 1536, 0, 1, 0, 31, 27, 0, 0, 1176563511, 1, 'Sidemap', 1, '', 0, 0, 0, 0, '', 0, 0, 0, 1, 0, 0, 0, '', '', 0, '', '', 0, '', 0, 0, '', 0, 1176580880, '', '', 0, '', '', '', 0, 0, 0, 0, '', 0, 0, '', '0', '0');
INSERT INTO pages VALUES (63, 3, 0, 0, 0, '', 0, 0, 0, 0, 0, 0, 1179622995, 256, 0, 1, 0, 31, 27, 0, 0, 1179621942, 1, 'Gallery2', 2, '', 0, 0, 0, 0, '', 0, 0, 0, 1, 0, 0, 0, '', '', 0, '', '', 0, '', 0, 0, '', 0, 1179623040, '', '', 0, '', '', '', 0, 65, 0, 0, '', 0, 0, '', '0', '0');
INSERT INTO pages VALUES (64, 63, 0, 0, 0, '', 0, 0, 0, 0, 0, 0, 1179622257, 256, 0, 1, 0, 31, 27, 0, 0, 1179621966, 1, 'Image', 2, '', 0, 0, 0, 0, '', 0, 0, 0, 1, 0, 0, 0, '', '', 0, '', '', 0, '', 0, 0, '', 0, 1179622257, '', '', 0, '', '', '', 1, 66, 0, 0, '', 0, 0, '', '0', '0');
INSERT INTO pages VALUES (65, 11, 0, 0, 0, '', 0, 0, 0, 0, 0, 0, 1179622038, 512, 0, 1, 0, 31, 27, 0, 0, 1179622038, 1, 'damd_gallery', 1, '', 0, 0, 0, 0, '', 0, 0, 0, 1, 0, 0, 0, '', '', 0, '', '', 0, '', 0, 0, '', 0, 0, '', '', 0, '', '', '', 0, 0, 0, 0, '', 0, 0, '', '0', '0');
INSERT INTO pages VALUES (66, 65, 0, 0, 0, '', 0, 0, 0, 0, 0, 0, 1179622051, 256, 0, 1, 0, 31, 27, 0, 0, 1179622051, 1, 'single', 1, '', 0, 0, 0, 0, '', 0, 0, 0, 1, 0, 0, 0, '', '', 0, '', '', 0, '', 0, 0, '', 0, 0, '', '', 0, '', '', '', 0, 0, 0, 0, '', 0, 0, '', '0', '0');
INSERT INTO pages VALUES (67, 5, 0, 0, 0, '', 0, 0, 0, 0, 0, 0, 1179624364, 256, 0, 1, 0, 31, 27, 0, 0, 1179623318, 1, 'Article', 2, '', 0, 0, 0, 0, '', 0, 0, 0, 1, 0, 0, 0, '', '', 0, '', '', 0, '', 0, 0, '', 0, 1179624364, '', '', 0, '', '', '', 1, 13, 0, 0, '', 0, 0, '', '0', '0');
INSERT INTO pages VALUES (68, 5, 0, 0, 0, '', 0, 0, 0, 0, 0, 0, 1179624545, 512, 0, 1, 0, 31, 27, 0, 0, 1179624411, 1, 'Archive', 2, '', 0, 0, 0, 0, '', 0, 0, 0, 1, 0, 0, 0, '', '', 0, '', '', 0, '', 0, 0, '', 0, 1179624545, '', '', 0, '', '', '', 0, 14, 0, 0, '', 0, 0, '', '0', '0');
